org.apache.tinkerpop.gremlin.process.computer

## Class GraphComputerTest.VertexProgramF

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.computer.util.StaticVertexProgram<Object>
  - - org.apache.tinkerpop.gremlin.process.computer.GraphComputerTest.VertexProgramF

- All Implemented Interfaces:
    Cloneable, VertexProgram<Object>
  Enclosing class:
    GraphComputerTest

      public static class GraphComputerTest.VertexProgramF
      extends StaticVertexProgram<Object>

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VertexProgram.Builder, VertexProgram.Features`

  - ### Field Summary

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VERTEX_PROGRAM`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `VertexProgramF()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `execute(Vertex vertex, Messenger<Object> messenger, Memory memory)` This method denotes the main body of the computation and is executed on each vertex in the graph.
    `Set<MemoryComputeKey>` | `getMemoryComputeKeys()` The `Memory` keys that will be used during the computation.
    `Set<MessageScope>` | `getMessageScopes(Memory memory)` This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program.
    `GraphComputer.Persist` | `getPreferredPersist()`
    `GraphComputer.ResultGraph` | `getPreferredResultGraph()`
    `Set<VertexComputeKey>` | `getVertexComputeKeys()` The `Element` properties that will be mutated during the computation.
    `void` | `setup(Memory memory)` The method is called at the beginning of the computation.
    `boolean` | `terminate(Memory memory)` The method is called at the end of each iteration to determine if the computation is complete.

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.computer.util.StaticVertexProgram

      `clone, storeState`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `createVertexProgram, getFeatures, getMapReducers, getMessageCombiner, getTraverserRequirements, loadState, workerIterationEnd, workerIterationStart`

- - ### Constructor Detail

    - #### VertexProgramF

          public VertexProgramF()

  - ### Method Detail

    - #### setup

          public void setup(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the beginning of the computation. The method is global to the `GraphComputer` and as such, is not called for each vertex. During this stage, the `Memory` should be initialized to to its "start state."
      Parameters:
        `memory` - The global memory of the GraphComputer

    - #### execute

          public void execute(Vertex vertex,
                              Messenger<Object> messenger,
                              Memory memory)

      Description copied from interface: `VertexProgram`
      This method denotes the main body of the computation and is executed on each vertex in the graph. This method is logically executed in parallel on all vertices in the graph. When the `Memory` is read, it is according to the aggregated state yielded in the previous iteration. When the `Memory` is written, the data will be aggregated at the end of the iteration for reading in the next iteration.
      Parameters:
        `vertex` - the `Vertex` to execute the `VertexProgram` on
        `messenger` - the messenger that moves data between vertices
        `memory` - the shared state between all vertices in the computation

    - #### terminate

          public boolean terminate(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the end of each iteration to determine if the computation is complete. The method is global to the `GraphComputer` and as such, is not called for each `Vertex`. The `Memory` maintains the aggregated data from the last execute() iteration.
      Parameters:
        `memory` - The global memory of the `GraphComputer`
      Returns:
        whether or not to halt the computation

    - #### getVertexComputeKeys

          public Set<VertexComputeKey> getVertexComputeKeys()

      Description copied from interface: `VertexProgram`
      The `Element` properties that will be mutated during the computation. All properties in the graph are readable, but only the keys specified here are writable. The default is an empty set.
      Returns:
        the set of element keys that will be mutated during the vertex program's execution

    - #### getMemoryComputeKeys

          public Set<MemoryComputeKey> getMemoryComputeKeys()

      Description copied from interface: `VertexProgram`
      The `Memory` keys that will be used during the computation. These are the only keys that can be read or written throughout the life of the `GraphComputer`. The default is an empty set.
      Returns:
        the set of memory keys that will be read/written

    - #### getMessageScopes

          public Set<MessageScope> getMessageScopes(Memory memory)

      Description copied from interface: `VertexProgram`
      This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program. The returned messages scopes are the scopes that will be used to send messages during the stated iteration. It is not a requirement that all stated messages scopes be used, just that it is possible that they be used during the iteration.
      Parameters:
        `memory` - an immutable form of the `Memory`
      Returns:
        all possible message scopes during said vertex program iteration

    - #### getPreferredResultGraph

          public GraphComputer.ResultGraph getPreferredResultGraph()

    - #### getPreferredPersist

          public GraphComputer.Persist getPreferredPersist()

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.